using MangaMap.Views;
namespace MangaMap;
using Models;
using System.ComponentModel;
using INotifyPropertyChanged = System.ComponentModel.INotifyPropertyChanged;

/// <summary>
/// Classe reprsentant le contenu d'en-tte personnalis (CustomHeader).
/// </summary>
public partial class NewContent1 : ContentView, INotifyPropertyChanged
{
    public Manager my_manager => (App.Current as App).MyManager;

    /// <summary>
    /// Constructeur du contenu d'en-tte personnalis.
    /// </summary>
    public NewContent1()
    {
        InitializeComponent();
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton d'accueil.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    async void ImageButton_Clicked(System.Object sender, System.EventArgs e)
    {
        await Shell.Current.GoToAsync("//page/homePage");
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton de paramtres.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    async void SettingButton_Clicked(object sender, System.EventArgs e)
    {
        await Shell.Current.GoToAsync("//page/secondaire/settingsPage");
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton de compte.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    async void AccountButton_Clicked(object sender, System.EventArgs e)
    {
        await Shell.Current.GoToAsync("//page/secondaire/connexionPage");
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton de liste.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    async void ListButton_Clicked(object sender, System.EventArgs e)
    {
        await Navigation.PushAsync(new listPage());
    }
}