using Models;

namespace MangaMap.Views.Composants
{
    /// <summary>
    /// Code-behind pour le UserControl StyleBouton.xaml.
    /// </summary>
    public partial class StyleBouton : ContentView
    {
        /// <summary>
        /// Instance du manager pour accder aux donnes.
        /// </summary>
        public Manager my_manager => (App.Current as App).MyManager;

        /// <summary>
        /// Constructeur de la classe StyleBouton.
        /// </summary>
        public StyleBouton()
        {
            InitializeComponent();
            BindingContext = my_manager;
        }

        /// <summary>
        /// Gre l'vnement lorsqu'une image d'anime est clique.
        /// </summary>
        /// <param name="sender">L'objet dclenchant l'vnement.</param>
        /// <param name="e">Les arguments de l'vnement.</param>
        private async void AnimeImageClickedList(object sender, EventArgs e)
        {
            var selectedAnime = (sender as ImageButton)?.BindingContext as Oeuvre;
            if (selectedAnime != null)
            {
                // Naviguez vers la page de la fiche d'anime en passant l'objet slectionn
                await Navigation.PushAsync(new ficheAnime(selectedAnime));
            }
        }
    }
}
