using System.Text.RegularExpressions;
using Models;
using static System.Runtime.InteropServices.JavaScript.JSType;
using System.Threading.Tasks;
using Microsoft.Maui.Storage;

namespace MangaMap.Views;

public partial class createOeuvre : ContentPage
{
    public Manager my_manager => (App.Current as App).MyManager;
    private string imagePath;

    /// <summary>
    /// Constructeur de la page de cration d'oeuvre.
    /// </summary>
    public createOeuvre()
    {
        InitializeComponent();
        BindingContext = this;
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton de slection d'image.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    private async void SelectImageClicked(object sender, EventArgs e)
    {
        var result = await FilePicker.PickAsync(new PickOptions
        {
            FileTypes = FilePickerFileType.Images,
            PickerTitle = "Pick an image"
        });

        if (result != null)
        {
            var stream = await result.OpenReadAsync();
            // Utilisez le chemin d'accs  l'image slectionne
            imagePath = result.FullPath;
        }
    }

    /// <summary>
    /// Gre l'vnement de clic sur le bouton d'ajout d'oeuvre.
    /// </summary>
    /// <param name="sender">L'objet dclencheur de l'vnement.</param>
    /// <param name="e">Les arguments de l'vnement.</param>
    private async void AddClicked(object sender, System.EventArgs e)
    {
        // Rcuprer les valeurs des entres
        string nom = nameEntry.Text;
        string type = typeEntry.Text;
        int nbEp = Convert.ToInt32(nbEpisodeEntry.Text);
        string description = descriptionEntry.Text;

        foreach (Oeuvre o in my_manager.Oeuvres)
        {
            if (o.Nom == nom)
            {
                await DisplayAlert("Erreur", "L'oeuvre existe dj.", "OK");
                return;
            }
        }

        if (string.IsNullOrWhiteSpace(nom) ||
            string.IsNullOrWhiteSpace(description) || string.IsNullOrWhiteSpace(type))
        {
            await DisplayAlert("Erreur", "Veuillez remplir tous les champs.", "OK");
            return;
        }

        if (nbEp < 0)
        {
            await DisplayAlert("Erreur", "Il faut avoir au moins 1 pisode pour l'application.", "OK");
            return;
        }

        Oeuvre oeuv = new Oeuvre(nom, type, description, nbEp, imagePath);
        my_manager.Oeuvres.Add(oeuv);
        my_manager.sauvegarder();
        await Navigation.PushAsync(new homePage());
        return;
    }
}
