namespace MangaMap.Views;
using Models;

/// <summary>
/// Classe reprsentant la page des paramtres de l'application.
/// </summary>
public partial class settingsPage : ContentPage
{
    /// <summary>
    /// Rfrence au gestionnaire de l'application.
    /// </summary>
    public Manager my_manager => (App.Current as App).MyManager;

    /// <summary>
    /// Constructeur de la page des paramtres.
    /// </summary>
    public settingsPage()
    {
        InitializeComponent();
    }

    /// <summary>
    /// Gestionnaire d'vnement lorsqu'un utilisateur clique sur le bouton "Dconnexion".
    /// </summary>
    /// <param name="sender">L'objet qui a dclench l'vnement.</param>
    /// <param name="e">Arguments de l'vnement.</param>
    private async void OnDisconnectClicked(object sender, EventArgs e)
    {
        my_manager.UtilisateurActuel = new Utilisateur();
        my_manager.isAdmin = false;
        await Shell.Current.GoToAsync("//page/secondaire/connexionPage");
    }

    /// <summary>
    /// Gestionnaire d'vnement lorsqu'un utilisateur clique sur le bouton "Connexion Administrateur".
    /// </summary>
    /// <param name="sender">L'objet qui a dclench l'vnement.</param>
    /// <param name="e">Arguments de l'vnement.</param>
    private async void LoginAdminClicked(object sender, EventArgs e)
    {
        await Shell.Current.Navigation.PushAsync(new loginAdminPage());
    }

    /// <summary>
    /// Gestionnaire d'vnement lorsqu'un utilisateur clique sur le bouton "Ajouter".
    /// </summary>
    /// <param name="sender">L'objet qui a dclench l'vnement.</param>
    /// <param name="e">Arguments de l'vnement.</param>
    private async void AddClicked(object sender, EventArgs e)
    {
        if (!my_manager.isAdmin)
        {
            await DisplayAlert("Erreur", "Vous n'tes pas connect en tant qu'Administrateur.", "OK");
            return;
        }
        await Shell.Current.Navigation.PushAsync(new createOeuvre());
    }
}